local addonName, addon = ...

local function print(...)
  _G.print("|cffff7d0a" .. addonName .. "|r: ", ...)
end

local omniCursor = UIParent:CreateTexture(nil, "OVERLAY", nil, 7)
omniCursor:SetTexture("Interface\\AddOns\\" .. addonName .. "\\Point")
--omniCursor:SetGradient("VERTICAL", 0, 0, 0, 1, 1, 1)
--omniCursor:SetGradientAlpha("VERTICAL", 0, 0, 0, .5, .5, .5, .5, .5)
--omniCursor:SetAlpha(.25)
--omniCursor:SetVertexColor(0, 0, 0, .5)
omniCursor:SetVertexColor(.25, .25, .25, .5)

local frame = CreateFrame("Frame")

local oldX, oldY = 0, 0

local levelOfConcealment = 0

local function onCursorHidden()
   local x, y = GetCursorPosition()
   local scale = UIParent:GetEffectiveScale()
   omniCursor:SetSize(22.75 / scale, 22.75 / scale)
   omniCursor:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x / scale, y / scale)
   omniCursor:Show()
   levelOfConcealment = levelOfConcealment + 1
   oldX, oldY = x, y
end

local function onCursorShown()
   levelOfConcealment = 0
   omniCursor:Hide()
end

local function onCursorMaybeShown()
   levelOfConcealment = math.max(levelOfConcealment - 1, 0)
   if levelOfConcealment == 0 then
      omniCursor:Hide()
   end
end

----[[
hooksecurefunc("CameraOrSelectOrMoveStart", onCursorHidden)
hooksecurefunc("CameraOrSelectOrMoveStop", onCursorMaybeShown)

hooksecurefunc("MouselookStart", onCursorHidden)
hooksecurefunc("MouselookStop", onCursorMaybeShown)

hooksecurefunc("TurnOrActionStart", onCursorHidden)
hooksecurefunc("TurnOrActionStop", onCursorMaybeShown)
--]]

----[[
hooksecurefunc("MoveAndSteerStart", onCursorHidden)
hooksecurefunc("MoveAndSteerStop", onCursorMaybeShown)
--]]

frame:SetScript("OnUpdate", function(self, elaspsed)
  local x, y = GetCursorPosition()
  if omniCursor:IsShown() and (x ~= oldX or y ~= oldY) then
    onCursorShown()
    oldX, oldY = x, y
  end
end)

--[[
frame:SetScript("OnUpdate", function(self, elaspsed)
  if IsMouselooking() then
    if not omniCursor:IsShown() then
      onCursorHidden()
    end
  elseif omniCursor:IsShown() then
    onCursorMaybeShown()
  end
end)
]]

--[[
frame:SetScript("OnUpdate", function(self, elaspsed)
  if UIParent:IsMouseOver() then
    local mouseFocus = GetMouseFocus()
    --print(GetTime(), mouseFocus:GetName() or tostring(mouseFocus))
  end
end)
]]

--[[
hooksecurefunc("SetCursor", function(cursor)
  print("SetCursor")
end)
]]

-- vim: tw=120 sts=2 sw=2 et
