local addonName, addon = ...

setfenv(1, addon)

-- Based on ownedcore.com/forums/world-of-warcraft/world-of-warcraft-bots-programs/wow-memory-editing/496760-cvar-list-b
-- uild-x86-19034-tips.html. I had to comment some CVars out since my version of WoW doesn't recognize them.  Quotations
-- marks are needed here because the shortcut syntax is only valid for string constants used as keys.
allCVars = {
   "ActionButtonUseKeyDown",
   "activeCUFProfile",
   "addFriendInfoShown",
   "advancedCombatLogging",
   "advancedWatchFrame",
   "agentUID",
   "allowCompareWithToggle",
   "alternateResourceText",
   "alwaysCompareItems",
   "alwaysShowActionBars",
   "animFrameSkipLOD",
   "assistAttack",
   "asyncHandlerTimeout",
   "asyncThreadSleep",
   "auctionDisplayOnCharacter",
   "audioLocale",
   "autoClearAFK",
   "autoCompleteResortNamesOnRecency",
   "autoCompleteUseContext",
   "autoCompleteWhenEditingFromCenter",
   "autoDismount",
   "autoDismountFlying",
   "autoFilledMultiCastSlots",
   "autoInteract",
   "autojoinBGVoice",
   "autojoinPartyVoice",
   "autoLootDefault",
   "autoLootRate",
   "autoOpenLootHistory",
   "autoQuestPopUps",
   "autoQuestProgress",
   "autoQuestWatch",
   "autoSelfCast",
   "autoStand",
   "autoUnshift",
   --"baseMip",
   "bloatnameplates",
   "bloatTest",
   "bloatthreat",
   "blockChannelInvites",
   "blockTrades",
   "bnetLogSeverity",
   "bnWhisperMode",
   "bodyQuota",
   "breakUpLargeNumbers",
   "BrowserNavigateLog",
   "bspcache",
   "buffDurations",
   "calendarShowBattlegrounds",
   "calendarShowDarkmoon",
   "calendarShowLockouts",
   "calendarShowResets",
   "calendarShowWeeklyHolidays",
   "cameraBobbing",
   "cameraBobbingSmoothSpeed",
   "cameraCustomViewSmoothing",
   "cameraDistanceMax",
   "cameraDistanceMaxFactor",
   "cameraDistanceMoveSpeed",
   "cameraDistanceSmoothSpeed",
   "cameraDive",
   "cameraFlyingMountHeightSmoothSpeed",
   "cameraFoVSmoothSpeed",
   "cameraGroundSmoothSpeed",
   "cameraHeightIgnoreStandState",
   "cameraHeightSmoothSpeed",
   "cameraPitchMoveSpeed",
   "cameraPitchSmoothMax",
   "cameraPitchSmoothMin",
   "cameraPitchSmoothSpeed",
   "cameraPivot",
   "cameraPivotDXMax",
   "cameraPivotDYMin",
   "cameraSavedDistance",
   "cameraSavedPetBattleDistance",
   "cameraSavedPitch",
   "cameraSavedVehicleDistance",
   "camerasmooth",
   "cameraSmoothAlwaysFearDelay",
   "cameraSmoothAlwaysFearFactor",
   "cameraSmoothAlwaysIdleDelay",
   "cameraSmoothAlwaysIdleFactor",
   "cameraSmoothAlwaysMoveDelay",
   "cameraSmoothAlwaysMoveFactor",
   "cameraSmoothAlwaysStopDelay",
   "cameraSmoothAlwaysStopFactor",
   "cameraSmoothAlwaysStrafeDelay",
   "cameraSmoothAlwaysStrafeFactor",
   "cameraSmoothAlwaysTrackDelay",
   "cameraSmoothAlwaysTrackFactor",
   "cameraSmoothAlwaysTurnDelay",
   "cameraSmoothAlwaysTurnFactor",
   "cameraSmoothNeverFearDelay",
   "cameraSmoothNeverFearFactor",
   "cameraSmoothNeverIdleDelay",
   "cameraSmoothNeverIdleFactor",
   "cameraSmoothNeverMoveDelay",
   "cameraSmoothNeverMoveFactor",
   "cameraSmoothNeverStopDelay",
   "cameraSmoothNeverStopFactor",
   "cameraSmoothNeverStrafeDelay",
   "cameraSmoothNeverStrafeFactor",
   "cameraSmoothNeverTrackDelay",
   "cameraSmoothNeverTrackFactor",
   "cameraSmoothNeverTurnDelay",
   "cameraSmoothNeverTurnFactor",
   "cameraSmoothPitch",
   "cameraSmoothSmarterFearDelay",
   "cameraSmoothSmarterFearFactor",
   "cameraSmoothSmarterIdleDelay",
   "cameraSmoothSmarterIdleFactor",
   "cameraSmoothSmarterMoveDelay",
   "cameraSmoothSmarterMoveFactor",
   "cameraSmoothSmarterStopDelay",
   "cameraSmoothSmarterStopFactor",
   "cameraSmoothSmarterStrafeDelay",
   "cameraSmoothSmarterStrafeFactor",
   "cameraSmoothSmarterTrackDelay",
   "cameraSmoothSmarterTrackFactor",
   "cameraSmoothSmarterTurnDelay",
   "cameraSmoothSmarterTurnFactor",
   "cameraSmoothSmartFearDelay",
   "cameraSmoothSmartFearFactor",
   "cameraSmoothSmartIdleDelay",
   "cameraSmoothSmartIdleFactor",
   "cameraSmoothSmartMoveDelay",
   "cameraSmoothSmartMoveFactor",
   "cameraSmoothSmartStopDelay",
   "cameraSmoothSmartStopFactor",
   "cameraSmoothSmartStrafeDelay",
   "cameraSmoothSmartStrafeFactor",
   "cameraSmoothSmartTrackDelay",
   "cameraSmoothSmartTrackFactor",
   "cameraSmoothSmartTurnDelay",
   "cameraSmoothSmartTurnFactor",
   "cameraSmoothSplineFearDelay",
   "cameraSmoothSplineFearFactor",
   "cameraSmoothSplineIdleDelay",
   "cameraSmoothSplineIdleFactor",
   "cameraSmoothSplineMoveDelay",
   "cameraSmoothSplineMoveFactor",
   "cameraSmoothSplineStopDelay",
   "cameraSmoothSplineStopFactor",
   "cameraSmoothSplineStrafeDelay",
   "cameraSmoothSplineStrafeFactor",
   "cameraSmoothSplineTrackDelay",
   "cameraSmoothSplineTrackFactor",
   "cameraSmoothSplineTurnDelay",
   "cameraSmoothSplineTurnFactor",
   "cameraSmoothStyle",
   "cameraSmoothTimeMax",
   "cameraSmoothTimeMin",
   "cameraSmoothTrackingStyle",
   "cameraSmoothViewDataAlwaysDistanceDelay",
   "cameraSmoothViewDataAlwaysDistanceFactor",
   "cameraSmoothViewDataAlwaysPitchDelay",
   "cameraSmoothViewDataAlwaysPitchFactor",
   "cameraSmoothViewDataAlwaysYawDelay",
   "cameraSmoothViewDataAlwaysYawFactor",
   "cameraSmoothViewDataNeverDistanceDelay",
   "cameraSmoothViewDataNeverDistanceFactor",
   "cameraSmoothViewDataNeverPitchDelay",
   "cameraSmoothViewDataNeverPitchFactor",
   "cameraSmoothViewDataNeverYawDelay",
   "cameraSmoothViewDataNeverYawFactor",
   "cameraSmoothViewDataSmartDistanceDelay",
   "cameraSmoothViewDataSmartDistanceFactor",
   "cameraSmoothViewDataSmarterDistanceDelay",
   "cameraSmoothViewDataSmarterDistanceFactor",
   "cameraSmoothViewDataSmarterPitchDelay",
   "cameraSmoothViewDataSmarterPitchFactor",
   "cameraSmoothViewDataSmarterYawDelay",
   "cameraSmoothViewDataSmarterYawFactor",
   "cameraSmoothViewDataSmartPitchDelay",
   "cameraSmoothViewDataSmartPitchFactor",
   "cameraSmoothViewDataSmartYawDelay",
   "cameraSmoothViewDataSmartYawFactor",
   "cameraSmoothViewDataSplineDistanceDelay",
   "cameraSmoothViewDataSplineDistanceFactor",
   "cameraSmoothViewDataSplinePitchDelay",
   "cameraSmoothViewDataSplinePitchFactor",
   "cameraSmoothViewDataSplineYawDelay",
   "cameraSmoothViewDataSplineYawFactor",
   "cameraSmoothYaw",
   "cameraSubmergeFinalPitch",
   "cameraSubmergePitch",
   "cameraSurfaceFinalPitch",
   "cameraSurfacePitch",
   "cameraTargetSmoothSpeed",
   "cameraTerrainTilt",
   "cameraTerrainTiltAlwaysFallAbsorb",
   "cameraTerrainTiltAlwaysFallDelay",
   "cameraTerrainTiltAlwaysFallFactor",
   "cameraTerrainTiltAlwaysFearAbsorb",
   "cameraTerrainTiltAlwaysFearDelay",
   "cameraTerrainTiltAlwaysFearFactor",
   "cameraTerrainTiltAlwaysIdleAbsorb",
   "cameraTerrainTiltAlwaysIdleDelay",
   "cameraTerrainTiltAlwaysIdleFactor",
   "cameraTerrainTiltAlwaysJumpAbsorb",
   "cameraTerrainTiltAlwaysJumpDelay",
   "cameraTerrainTiltAlwaysJumpFactor",
   "cameraTerrainTiltAlwaysMoveAbsorb",
   "cameraTerrainTiltAlwaysMoveDelay",
   "cameraTerrainTiltAlwaysMoveFactor",
   "cameraTerrainTiltAlwaysStrafeAbsorb",
   "cameraTerrainTiltAlwaysStrafeDelay",
   "cameraTerrainTiltAlwaysStrafeFactor",
   "cameraTerrainTiltAlwaysSwimAbsorb",
   "cameraTerrainTiltAlwaysSwimDelay",
   "cameraTerrainTiltAlwaysSwimFactor",
   "cameraTerrainTiltAlwaysTaxiAbsorb",
   "cameraTerrainTiltAlwaysTaxiDelay",
   "cameraTerrainTiltAlwaysTaxiFactor",
   "cameraTerrainTiltAlwaysTrackAbsorb",
   "cameraTerrainTiltAlwaysTrackDelay",
   "cameraTerrainTiltAlwaysTrackFactor",
   "cameraTerrainTiltAlwaysTurnAbsorb",
   "cameraTerrainTiltAlwaysTurnDelay",
   "cameraTerrainTiltAlwaysTurnFactor",
   "cameraTerrainTiltNeverFallAbsorb",
   "cameraTerrainTiltNeverFallDelay",
   "cameraTerrainTiltNeverFallFactor",
   "cameraTerrainTiltNeverFearAbsorb",
   "cameraTerrainTiltNeverFearDelay",
   "cameraTerrainTiltNeverFearFactor",
   "cameraTerrainTiltNeverIdleAbsorb",
   "cameraTerrainTiltNeverIdleDelay",
   "cameraTerrainTiltNeverIdleFactor",
   "cameraTerrainTiltNeverJumpAbsorb",
   "cameraTerrainTiltNeverJumpDelay",
   "cameraTerrainTiltNeverJumpFactor",
   "cameraTerrainTiltNeverMoveAbsorb",
   "cameraTerrainTiltNeverMoveDelay",
   "cameraTerrainTiltNeverMoveFactor",
   "cameraTerrainTiltNeverStrafeAbsorb",
   "cameraTerrainTiltNeverStrafeDelay",
   "cameraTerrainTiltNeverStrafeFactor",
   "cameraTerrainTiltNeverSwimAbsorb",
   "cameraTerrainTiltNeverSwimDelay",
   "cameraTerrainTiltNeverSwimFactor",
   "cameraTerrainTiltNeverTaxiAbsorb",
   "cameraTerrainTiltNeverTaxiDelay",
   "cameraTerrainTiltNeverTaxiFactor",
   "cameraTerrainTiltNeverTrackAbsorb",
   "cameraTerrainTiltNeverTrackDelay",
   "cameraTerrainTiltNeverTrackFactor",
   "cameraTerrainTiltNeverTurnAbsorb",
   "cameraTerrainTiltNeverTurnDelay",
   "cameraTerrainTiltNeverTurnFactor",
   "cameraTerrainTiltSmarterFallAbsorb",
   "cameraTerrainTiltSmarterFallDelay",
   "cameraTerrainTiltSmarterFallFactor",
   "cameraTerrainTiltSmarterFearAbsorb",
   "cameraTerrainTiltSmarterFearDelay",
   "cameraTerrainTiltSmarterFearFactor",
   "cameraTerrainTiltSmarterIdleAbsorb",
   "cameraTerrainTiltSmarterIdleDelay",
   "cameraTerrainTiltSmarterIdleFactor",
   "cameraTerrainTiltSmarterJumpAbsorb",
   "cameraTerrainTiltSmarterJumpDelay",
   "cameraTerrainTiltSmarterJumpFactor",
   "cameraTerrainTiltSmarterMoveAbsorb",
   "cameraTerrainTiltSmarterMoveDelay",
   "cameraTerrainTiltSmarterMoveFactor",
   "cameraTerrainTiltSmarterStrafeAbsorb",
   "cameraTerrainTiltSmarterStrafeDelay",
   "cameraTerrainTiltSmarterStrafeFactor",
   "cameraTerrainTiltSmarterSwimAbsorb",
   "cameraTerrainTiltSmarterSwimDelay",
   "cameraTerrainTiltSmarterSwimFactor",
   "cameraTerrainTiltSmarterTaxiAbsorb",
   "cameraTerrainTiltSmarterTaxiDelay",
   "cameraTerrainTiltSmarterTaxiFactor",
   "cameraTerrainTiltSmarterTrackAbsorb",
   "cameraTerrainTiltSmarterTrackDelay",
   "cameraTerrainTiltSmarterTrackFactor",
   "cameraTerrainTiltSmarterTurnAbsorb",
   "cameraTerrainTiltSmarterTurnDelay",
   "cameraTerrainTiltSmarterTurnFactor",
   "cameraTerrainTiltSmartFallAbsorb",
   "cameraTerrainTiltSmartFallDelay",
   "cameraTerrainTiltSmartFallFactor",
   "cameraTerrainTiltSmartFearAbsorb",
   "cameraTerrainTiltSmartFearDelay",
   "cameraTerrainTiltSmartFearFactor",
   "cameraTerrainTiltSmartIdleAbsorb",
   "cameraTerrainTiltSmartIdleDelay",
   "cameraTerrainTiltSmartIdleFactor",
   "cameraTerrainTiltSmartJumpAbsorb",
   "cameraTerrainTiltSmartJumpDelay",
   "cameraTerrainTiltSmartJumpFactor",
   "cameraTerrainTiltSmartMoveAbsorb",
   "cameraTerrainTiltSmartMoveDelay",
   "cameraTerrainTiltSmartMoveFactor",
   "cameraTerrainTiltSmartStrafeAbsorb",
   "cameraTerrainTiltSmartStrafeDelay",
   "cameraTerrainTiltSmartStrafeFactor",
   "cameraTerrainTiltSmartSwimAbsorb",
   "cameraTerrainTiltSmartSwimDelay",
   "cameraTerrainTiltSmartSwimFactor",
   "cameraTerrainTiltSmartTaxiAbsorb",
   "cameraTerrainTiltSmartTaxiDelay",
   "cameraTerrainTiltSmartTaxiFactor",
   "cameraTerrainTiltSmartTrackAbsorb",
   "cameraTerrainTiltSmartTrackDelay",
   "cameraTerrainTiltSmartTrackFactor",
   "cameraTerrainTiltSmartTurnAbsorb",
   "cameraTerrainTiltSmartTurnDelay",
   "cameraTerrainTiltSmartTurnFactor",
   "cameraTerrainTiltSplineFallAbsorb",
   "cameraTerrainTiltSplineFallDelay",
   "cameraTerrainTiltSplineFallFactor",
   "cameraTerrainTiltSplineFearAbsorb",
   "cameraTerrainTiltSplineFearDelay",
   "cameraTerrainTiltSplineFearFactor",
   "cameraTerrainTiltSplineIdleAbsorb",
   "cameraTerrainTiltSplineIdleDelay",
   "cameraTerrainTiltSplineIdleFactor",
   "cameraTerrainTiltSplineJumpAbsorb",
   "cameraTerrainTiltSplineJumpDelay",
   "cameraTerrainTiltSplineJumpFactor",
   "cameraTerrainTiltSplineMoveAbsorb",
   "cameraTerrainTiltSplineMoveDelay",
   "cameraTerrainTiltSplineMoveFactor",
   "cameraTerrainTiltSplineStrafeAbsorb",
   "cameraTerrainTiltSplineStrafeDelay",
   "cameraTerrainTiltSplineStrafeFactor",
   "cameraTerrainTiltSplineSwimAbsorb",
   "cameraTerrainTiltSplineSwimDelay",
   "cameraTerrainTiltSplineSwimFactor",
   "cameraTerrainTiltSplineTaxiAbsorb",
   "cameraTerrainTiltSplineTaxiDelay",
   "cameraTerrainTiltSplineTaxiFactor",
   "cameraTerrainTiltSplineTrackAbsorb",
   "cameraTerrainTiltSplineTrackDelay",
   "cameraTerrainTiltSplineTrackFactor",
   "cameraTerrainTiltSplineTurnAbsorb",
   "cameraTerrainTiltSplineTurnDelay",
   "cameraTerrainTiltSplineTurnFactor",
   "cameraTerrainTiltTimeMax",
   "cameraTerrainTiltTimeMin",
   "cameraView",
   "cameraViewBlendStyle",
   "cameraWaterCollision",
   "cameraYawMoveSpeed",
   "cameraYawSmoothMax",
   "cameraYawSmoothMin",
   "cameraYawSmoothSpeed",
   "characterFrameCollapsed",
   "ChatAmbienceVolume",
   "chatBubbles",
   "chatBubblesParty",
   "chatMouseScroll",
   "ChatMusicVolume",
   "ChatSoundVolume",
   "chatStyle",
   "checkAddonVersion",
   "closedInfoFrames",
   "colorblindMode",
   "colorChatNamesByClass",
   "CombatDamage",
   "CombatDamageStyle",
   "CombatHealing",
   "CombatHealingAbsorbSelf",
   "CombatHealingAbsorbTarget",
   "CombatLogPeriodicSpells",
   "combatLogReducedRetentionTime",
   "combatLogRetentionTime",
   "combatTextFloatMode",
   "componentCompress",
   "componentTexCacheSize",
   "componentTexLoadLimit",
   "componentTextureLevel",
   "componentThread",
   "consolidateBuffs",
   "conversationMode",
   "countdownForCooldowns",
   "currencyTokensBackpack1",
   "currencyTokensBackpack2",
   "currencyTokensUnused1",
   "currencyTokensUnused2",
   "DepthBasedOpacity",
   "deselectOnClick",
   "DesktopGamma",
   "detailDoodadInstancing",
   "digSites",
   "disableServerNagle",
   "displayedRAFFriendInfo",
   "displayFreeBagSlots",
   "displaySpellActivationOverlays",
   "displayWorldPVPObjectives",
   "dontShowEquipmentSetsOnItems",
   "doodadUnloadDist",
   "EJLootClass",
   "EJLootSpec",
   "EmitterCombatRange",
   "emphasizeMySpellEffects",
   "enableBGDL",
   "enableCombatText",
   "EnableMicrophone",
   "enableMouseSpeed",
   "enableMovePad",
   "enablePetBattleCombatText",
   "enablePVPNotifyAFK",
   "EnableVoiceChat",
   "enableWowMouse",
   "entityLodDist",
   "environmentDetail",
   "ErrorFilter",
   "ErrorLevelMax",
   "ErrorLevelMin",
   "Errors",
   "expandUpgradePanel",
   "farclip",
   "fctAllSpellMechanics",
   "fctAuras",
   "fctCombatState",
   "fctComboPoints",
   "fctDamageReduction",
   "fctDodgeParryMiss",
   "fctEnergyGains",
   "fctFriendlyHealers",
   "fctHonorGains",
   "fctLowManaHealth",
   "fctPeriodicEnergyGains",
   "fctReactives",
   "fctRepChanges",
   "fctSpellMechanics",
   "fctSpellMechanicsOther",
   "ffxAntiAliasingMode",
   "ffxGlow",
   "ffxRectangle",
   "flaggedTutorials",
   "FootstepSounds",
   "forceEnglishNames",
   "friendsSmallView",
   "friendsViewButtons",
   "fullDump",
   "fullSizeFocusFrame",
   "GameObjForceMouseOver",
   "gameTip",
   "Gamma",
   "graphicsQuality",
   "groundEffectDensity",
   "groundEffectDist",
   "groundEffectFade",
   "guildMemberNotify",
   "guildNewsFilter",
   "guildRewardsCategory",
   "guildRewardsUsable",
   "guildRosterView",
   "guildShowOffline",
   "gxAdapter",
   "gxAFRDevicesCount",
   "gxApi",
   "gxAspect",
   "gxColorBits",
   "gxCursor",
   "gxDepthBits",
   "gxDepthResolveHandleCaching",
   "gxDisableStencil",
   "gxFixLag",
   "gxMaximize",
   "gxMonitor",
   "gxOverride",
   "gxRefresh",
   "gxResolution",
   "gxStereoConvergence",
   "gxStereoEnabled",
   "gxStereoSeparation",
   "gxTextureCacheSize",
   "gxTripleBuffer",
   "gxVSync",
   "gxWindow",
   "hardTrackedQuests",
   "hdPlayerModels",
   "horizonFarclipScale",
   "horizonNearclipScale",
   "hwDetect",
   "hwPCF",
   "InboundChatVolume",
   "interactOnLeftClick",
   "lastAddonVersion",
   "lastCharacterIndex",
   "lastGarrisonMissionTutorial",
   --"lastReadEULA",
   "lastReadTerminationWithoutNotice",
   --"lastReadTOS",
   "lastTalkedToGM",
   "lastVoidStorageTutorial",
   "launchAgent",
   "lfdCollapsedHeaders",
   "lfdSelectedDungeons",
   "lfgAutoFill",
   "lfgAutoJoin",
   "lfgSelectedRoles",
   "lfGuildComment",
   "lfGuildSettings",
   "locale",
   "lockActionBars",
   "lockedWorldMap",
   "lootUnderMouse",
   "lossOfControl",
   "lossOfControlDisarm",
   "lossOfControlFull",
   "lossOfControlInterrupt",
   "lossOfControlRoot",
   "lossOfControlSilence",
   "M2ForceAdditiveParticleSort",
   "M2UseInstancing",
   "M2UseLOD",
   "M2UseThreads",
   "mapAnimDuration",
   "mapAnimMinAlpha",
   "mapAnimStartDelay",
   "mapFade",
   "maxAlgoplates",
   "maxAnimJobs",
   "maxFPS",
   "maxFPSBk",
   "MaxObservedPetBattles",
   "maxSpellStartRecoveryOffset",
   "minimapInsideZoom",
   "minimapPortalMax",
   "minimapShapeshiftTracking",
   "minimapShowArchBlobs",
   "minimapShowQuestBlobs",
   "minimapTrackedInfov2",
   "minimapZoom",
   "miniWorldMap",
   "mountJournalFilters",
   "mouseInvertPitch",
   "mouseInvertYaw",
   "mouseSpeed",
   "movieSubtitle",
   "nameplateMotion",
   "nameplateOverlapH",
   "nameplateOverlapV",
   "nameplateShowEnemies",
   "nameplateShowEnemyGuardians",
   "nameplateShowEnemyMinus",
   "nameplateShowEnemyPets",
   "nameplateShowEnemyTotems",
   "nameplateShowFriendlyGuardians",
   "nameplateShowFriendlyPets",
   "nameplateShowFriendlyTotems",
   "nameplateShowFriends",
   "NamePlateStlye",
   "nearclip",
   "NonEmitterCombatRange",
   --"normalBufferMode",
   "ObjectSelectionCircle",
   "OutboundChatVolume",
   "Outline",
   "OutlineEngineMode",
   "outlineMouseOverFadeDuration",
   "outlineSelectionFadeDuration",
   "overrideArchive",
   "particleDensity",
   "partyBackgroundOpacity",
   "partyStatusText",
   "pathSmoothing",
   "pendingInviteInfoShown",
   "petJournalFilters",
   "petJournalSort",
   "petJournalTab",
   "PetMeleeDamage",
   "PetSpellDamage",
   "petStatCategoriesCollapsed",
   "petStatCategoryOrder",
   "petStatusText",
   "playerStatLeftDropdown",
   "playerStatRightDropdown",
   "playerStatusText",
   "playIntroMovie",
   "POIShiftComplete",
   "portal",
   "predictedHealth",
   "predictedPower",
   "preloadLoadingDistObject",
   "preloadLoadingDistTerrain",
   "preloadPlayerModels",
   "preloadStreamingDistObject",
   "preloadStreamingDistTerrain",
   "processAffinityMask",
   "profanityFilter",
   "projectedTextures",
   "PushToTalkButton",
   "PushToTalkSound",
   "pvpBlacklistMaps0",
   "pvpBlacklistMaps1",
   "pvpSelectedRoles",
   "questLogCollapseHeaderFilter",
   "questLogOpen",
   "questPOI",
   "RAIDcomponentTextureLevel",
   "RAIDenvironmentDetail",
   "RAIDfarclip",
   "raidFramesDisplayAggroHighlight",
   "raidFramesDisplayClassColor",
   "raidFramesDisplayOnlyDispellableDebuffs",
   "raidFramesDisplayPowerBars",
   "raidFramesHealthText",
   "raidFramesHeight",
   "raidFramesPosition",
   "raidFramesWidth",
   "RAIDgraphicsQuality",
   "RAIDgroundEffectDensity",
   "RAIDgroundEffectDist",
   "RAIDgroundEffectFade",
   "raidOptionDisplayMainTankAndAssist",
   "raidOptionDisplayPets",
   "raidOptionIsShown",
   "raidOptionKeepGroupsTogether",
   "raidOptionLocked",
   "raidOptionShowBorders",
   "raidOptionSortMode",
   "RAIDparticleDensity",
   "RAIDprojectedTextures",
   "RAIDreflectionMode",
   "RAIDrefraction",
   "RAIDrippleDetail",
   "RAIDsettingsEnabled",
   "RAIDsettingsInit",
   "RAIDshadowMode",
   "RAIDshadowTextureSize",
   "RAIDSSAO",
   "RAIDSSAOBlur",
   "RAIDsunShafts",
   "RAIDterrainLodDist",
   "RAIDterrainMipLevel",
   "RAIDterrainTextureLod",
   "RAIDtextureFilteringMode",
   "RAIDWaterDetail",
   "RAIDweatherDensity",
   "RAIDwmoLodDist",
   "RAIDworldBaseMip",
   "readContest",
   --"readEULA",
   "readScanning",
   "readTerminationWithoutNotice",
   --"readTOS",
   "realmListbn",
   "realmName",
   "reducedLagTolerance",
   "reflectionDownscale",
   "reflectionMode",
   "refraction",
   "releaseUITextures",
   "removeChatDelay",
   "repositionfrequency",
   "reputationsCollapsed",
   "rippleDetail",
   "rotateMinimap",
   "sceneOcclusionEnable",
   "screenEdgeFlash",
   "screenshotFormat",
   "screenshotQuality",
   "scriptErrors",
   "scriptProfile",
   "scriptWarnings",
   "secureAbilityToggle",
   "seenAsiaCharacterUpgradePopup",
   "seenCharacterUpgradePopup",
   "serverAlert",
   "serviceTypeFilter",
   "shadowCull",
   "shadowInstancing",
   "shadowMode",
   "shadowScissor",
   "shadowTextureSize",
   "showAllEnemyDebuffs",
   "showArenaEnemyCastbar",
   "showArenaEnemyFrames",
   "showArenaEnemyPets",
   "showBattlefieldMinimap",
   "showBosses",
   "showCastableBuffs",
   "ShowClassColorInNameplate",
   "showDispelDebuffs",
   "showErrors",
   "showfootprintparticles",
   "showGameTips",
   "showNPETutorials",
   "showPartyBackground",
   "showPartyPets",
   "showQuestObjectivesOnMap",
   "showQuestTrackingTooltips",
   "showTamers",
   "showTargetCastbar",
   "showTargetOfTarget",
   "showTimestamps",
   "showToastBroadcast",
   "showToastConversation",
   "showToastFriendRequest",
   "showToastOffline",
   "showToastOnline",
   "showToastWindow",
   "showTokenFrame",
   "showTokenFrameHonor",
   "showTutorials",
   "showVKeyCastbar",
   "showVKeyCastbarOnlyOnTarget",
   "showVKeyCastbarSpellName",
   "simd",
   "skipStartGear",
   "SkyCloudLOD",
   "smoothUnitPhasing",
   "smoothUnitPhasingActorPurgatoryTimeMs",
   "smoothUnitPhasingAliveTimeoutMs",
   "smoothUnitPhasingDestroyedPurgatoryTimeMs",
   "smoothUnitPhasingDistThreshold",
   "smoothUnitPhasingEnableAlive",
   "smoothUnitPhasingUnseenPurgatoryTimeMs",
   "smoothUnitPhasingVehicleExtraTimeoutMs",
   "SoundUseNewBusSystem",
   "Sound_AmbienceVolume",
   "Sound_DialogVolume",
   "Sound_DSPBufferSize",
   "Sound_EnableAllSound",
   "Sound_EnableAmbience",
   "Sound_EnableArmorFoleySoundForOthers",
   "Sound_EnableArmorFoleySoundForSelf",
   "Sound_EnableDSPEffects",
   "Sound_EnableEmoteSounds",
   "Sound_EnableErrorSpeech",
   "Sound_EnableMixMode2",
   "Sound_EnableMode2",
   "Sound_EnableMusic",
   "Sound_EnablePetBattleMusic",
   "Sound_EnablePetSounds",
   "Sound_EnableReverb",
   "Sound_EnableSFX",
   "Sound_EnableSoftwareHRTF",
   "Sound_EnableSoundWhenGameIsInBG",
   "Sound_ListenerAtCharacter",
   "Sound_MasterVolume",
   "Sound_MaxCacheableSizeInBytes",
   "Sound_MaxCacheSizeInBytes",
   "Sound_MusicVolume",
   "Sound_NumChannels",
   "Sound_OutputDriverIndex",
   "Sound_OutputDriverName",
   "Sound_OutputSampleRate",
   "Sound_SFXVolume",
   "Sound_VoiceChatInputDriverIndex",
   "Sound_VoiceChatInputDriverName",
   "Sound_VoiceChatOutputDriverIndex",
   "Sound_VoiceChatOutputDriverName",
   "Sound_ZoneMusicNoDelay",
   "spamFilter",
   "spellActivationOverlayOpacity",
   "spellBookSort",
   "spellClutter",
   "spellClutterDefaultTargetScalar",
   "spellClutterHostileScalar",
   "spellClutterMinSpellCount",
   "spellClutterPartySizeScalar",
   "spellClutterPlayerScalarMultiplier",
   "spellClutterRangeConstant",
   "SpellTooltip_DisplayAvgValues",
   "splashScreenBoost",
   "splashScreenNormal",
   "SplineOpt",
   "SSAO",
   "SSAOBlur",
   "SSAODistance",
   "StartTalkingDelay",
   "StartTalkingTime",
   "statCategoriesCollapsed",
   "statCategoriesCollapsed_2",
   "statCategoryOrder",
   "statCategoryOrder_2",
   "statusTextDisplay",
   "stopAutoAttackOnTargetChange",
   "StopTalkingDelay",
   "StopTalkingTime",
   "streamBeams",
   "streamingCameraLookAheadTime",
   "streamingCameraMaxRadius",
   "streamingCameraRadius",
   "streamStatusMessage",
   "sunShafts",
   "superTrackerDist",
   "synchronizeBindings",
   "synchronizeChatFrames",
   "synchronizeConfig",
   "synchronizeMacros",
   "synchronizeSettings",
   "taintLog",
   "talentFrameShown",
   "talentPointsSpent",
   "targetOfTargetMode",
   "targetStatusText",
   "terrainAlphaBitDepth",
   "terrainHoles",
   "terrainLodDist",
   "terrainMipLevel",
   "terrainTextureLod",
   "textLocale",
   "textureFilteringMode",
   "threatPlaySounds",
   "threatShowNumeric",
   "threatWarning",
   "threatWorldText",
   "timeMgrAlarmEnabled",
   "timeMgrAlarmMessage",
   "timeMgrAlarmTime",
   "timeMgrUseLocalTime",
   "timeMgrUseMilitaryTime",
   "timingMethod",
   "timingTestError",
   "toastDuration",
   "trackedAchievements",
   "trackedQuests",
   "trackQuestSorting",
   "UberTooltips",
   "uiScale",
   "unitHighlights",
   "UnitNameEnemyGuardianName",
   "UnitNameEnemyPetName",
   "UnitNameEnemyPlayerName",
   "UnitNameEnemyTotemName",
   "UnitNameForceHideMinus",
   "UnitNameFriendlyGuardianName",
   "UnitNameFriendlyPetName",
   "UnitNameFriendlyPlayerName",
   "UnitNameFriendlySpecialNPCName",
   "UnitNameFriendlyTotemName",
   "UnitNameGuildTitle",
   "UnitNameHostleNPC",
   "UnitNameNonCombatCreatureName",
   "UnitNameNPC",
   "UnitNameOwn",
   "UnitNamePlayerGuild",
   "UnitNamePlayerPVPTitle",
   "useCompactPartyFrames",
   "useIPv6",
   "useUiScale",
   "videoOptionsVersion",
   "violenceLevel",
   "VoiceActivationSensitivity",
   "VoiceChatMode",
   "VoiceChatSelfMute",
   "watchFrameBaseAlpha",
   "watchFrameIgnoreCursor",
   "watchFrameState",
   "waterDetail",
   "weatherDensity",
   "whisperMode",
   "wholeChatWindowClickable",
   "windowResizeLock",
   "wmoDoodadDist",
   "wmoLodDist",
   "worldBaseMip",
   "worldMapOpacity",
   "worldMaxMipLevel",
   "worldPoolUsage",
   "WorldTextGravity",
   "WorldTextNonRandomZ",
   "WorldTextRandomXY",
   "WorldTextRandomZ",
   "WorldTextRandomZBase",
   "WorldTextStartPosRandomness",
   "xpBarText",
}

-- vim: tw=120 sts=2 sw=2 et
